#ifndef ___INC_slider_dialog_hpp___
#define ___INC_slider_dialog_hpp___

#include <QMap>
#include <QWidget>
#include <QVBoxLayout>
#include <QSocketNotifier>
#include <QIcon>
#include <QPixmap>
#include <QLabel>
#include <QTextStream>
#include <QTimer>

#include "dpe/image_allocator.hpp"
#include "mwdg/mixer_style.hpp"

#include "qas_slider.hpp"


class Slider_Dialog :
	public QWidget
{
	Q_OBJECT

	public:
	Slider_Dialog ( QMap<QString, QString> options );
	void setup_style();
	void setup_geometry( QPoint );
	void setup_io();

	private:
	Qas_Slider *_slider;
	QLabel *_lbl_icon;
	QTextStream qout;
	QTimer *_timer;
	QPixmap _pxmap;

	static const unsigned int _border_width = 1;
	static const unsigned int _corner_rad = 6;

	bool _update_pxmap;
	bool _stay_on_hover;
	bool _remains_on_hover;

	QSocketNotifier *notifier_in;

	::Wdg::DS_Widget_Style_Db _wdg_style_db;
	::dpe::Image_Allocator _image_alloc;

	QSize pixmap_size ( ) const;
	void set_icon ( const QIcon & icon_n );
	void set_pixmap ( const QPixmap & pixmap_n );

	void update_mask ( );
	void update_pixmap ( );
	void update_geometry ( );

	void mousePressEvent ( QMouseEvent * event_n ) override;

	bool eventFilter (
		QObject * obj_n,
		QEvent * event_n ) override;

//	protected:
//	void
//	leaveEvent (
//		QEvent * event_n ) override;

	void
	resizeEvent (
		QResizeEvent * event_n ) override;

	void
	paintEvent (
		QPaintEvent * event_n ) override;


	void update_slider( unsigned long v );

	private slots:
	void read_position();
	void write_position( unsigned long v );

    // QWidget interface
protected:
    void hideEvent(QHideEvent *event) override;
};

#endif
